<template>
  <div class="topics-wrapper">
    <div class="row">
      <div class="col-xs-8">
        <ul
          v-if="topics.length"
          class="topics-list"
        >
          <li
            v-for="topic in topics"
            :key="topic.topicUuid"
            :class="[ 'topic', { 'with-reply': topic.replies } ]"
          >
            <div :class="[ 'topic__content', { 'myself': participantUuid === topic.participantUuid } ]">
              <template v-if="topic.topicText === 'SYSTEM_QUESTION_FOR_STARTING_A_DIALOGUE'">
                <span class="topic__name">
                  Служба Поддержки:
                </span>

                Здесь организатор имеет возможность оставлять дополнительную информацию по тендеру,
                а участники могут задать вопрос организатору и получить на него ответ. Оставленные вопросы
                и ответы будут видны всем участникам тендера.
              </template>

              <template v-else>
                <span class="topic__name">
                  <span v-if="participantUuid === topic.participantUuid" class="-cobalt">Вы:</span>
                  <template v-else>Другой участник:</template>
                </span>

                {{ topic.topicText }}
              </template>
            </div>

            <ObAlert
              v-for="reply in topic.replies"
              :key="reply.replyUuid"
              :hide-close-button="true"
              class="reply"
              icon="info"
            >
              <b>Комментарий Клиента:</b> {{ reply.replyText }}
            </ObAlert>
          </li>
        </ul>

        <ObButton
          v-if="['HELD', 'SUMMARIZING'].includes(tender.status)"
          label="Задать вопрос"
          @click="addTopic"
        />

        <ObModal
          ref="addTopicModal"
          title="Ваш вопрос"
          size="md"
        >
          <addTopic
            :tender-uuid="tender.uuid"
            @submit="onTopicAdded"
          />
        </ObModal>
      </div>

      <div class="col-xs-2 col-xs-offset-2">
        <TenderInfo :tender="tender" />
      </div>
    </div>
  </div>
</template>

<script>
  import ObAlert from 'common-components/src/obComponents/obAlert'
  import ObButton from 'common-components/src/obComponents/obButton'
  import ObModal from 'common-components/src/obComponents/obModal'
  import addTopic from './modal/addTopic'
  import TenderInfo from './components/TenderInfo'
  import { mapGetters } from 'vuex'
  import api from '@/api'

  export default {
    name: 'tender-tab-buyer-topics',
    components: {
      TenderInfo,
      ObAlert,
      ObButton,
      ObModal,
      addTopic
    },
    props: {
      tender: {
        type: Object,
        required: true
      }
    },
    computed: {
      ...mapGetters({
        participantUuid: 'user/participantUuid'
      })
    },
    data () {
      return {
        topics: []
      }
    },
    async mounted () {
      await this.loadData()
    },
    methods: {
      async loadData () {
        const response = await api.tenders.getTopicsAndReplies(this.tender.uuid)

        this.topics = response.topics.sort((a, b) => a.pos - b.pos)
      },
      addTopic () {
        this.$refs.addTopicModal.open()
      },
      async onTopicAdded () {
        this.$refs.addTopicModal.close()

        await this.loadData()
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .topics-wrapper {
    padding: 30px 20px;
  }

  .topics-list {
    display: grid;
    grid-row-gap: 10px;
    margin: 0;
    padding: 0;
    list-style: none;

    &:not(:last-child) {
      margin-bottom: 20px;
    }
  }

  .topic {
    &.with-reply:not(:last-child) {
      margin-bottom: 10px;
    }

    &__content {
      @include font-mixin(14px, 18px, 400, $color-text-base);

      background-color: $color-white-lilac;
      padding: 12px 20px;
      display: flex;

      &:not(:last-child) {
        margin-bottom: 20px;
      }

      &.myself {
        background-color: $blue-150;
      }
    }

    &__name {
      font-weight: bold;
      white-space: nowrap;
      margin-right: 10px;
    }
  }

  .reply:last-child {
    margin-bottom: 0;
  }
</style>
